unit arduinoMacCfg;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.ListBox,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts, FMX.Edit, FMX.EditBox, FMX.SpinBox,
  FMX.TMSBaseControl, FMX.TMSGridCell, FMX.TMSGridOptions, FMX.TMSGridData,
  FMX.TMSCustomGrid, FMX.TMSGrid,
  Winsoft.OSX.ComPort;

type
  TArduinoDlg = class(TForm)
    SerialGB: TGroupBox;
    BaudCB: TComboBox;
    DeviceNameCB: TComboBox;
    TempsGB: TGroupBox;
    ModeGB: TGroupBox;
    PointRB: TRadioButton;
    TempsRB: TRadioButton;
    OKbtn: TButton;
    DureeMaxSE: TSpinBox;
    StartEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ExPointBtn: TButton;
    ExTempsBtn: TButton;
    ExEtalonBtn: TButton;
    EscapeBtn: TButton;
    Label4: TLabel;
    MonocoupCB: TCheckBox;
    tempsCB: TComboBox;
    TriggerCB: TComboBox;
    TriggerLabel: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TerminateurCB: TComboBox;
    GridLayout1: TGridLayout;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    commande1edit: TEdit;
    commande2Edit: TEdit;
    commande3Edit: TEdit;
    Label12: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    TempsArduinoCB: TCheckBox;
    ExTempsArduinoBtn: TButton;
    Label13: TLabel;
    stopEdit: TEdit;
    procedure ExPointBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PointRBChange(Sender: TObject);
    procedure tempsCBChange(Sender: TObject);
  private
  public
  end;

var
  ArduinoDlg: TArduinoDlg;

implementation

{$R *.fmx}

uses arduinoUMac, regutil;

procedure TArduinoDlg.ExPointBtnClick(Sender: TObject);
var chemin : string;
begin
   chemin := ExemplesPath+'/Arduino/';
   if sender=ExPointBtn then begin
       chemin := chemin+'simplePoint/simplePoint.ino';
       pointRB.isChecked := true;
   end;
   if sender=ExEtalonBtn then begin
       chemin := chemin+'etalon/etalon.ino';
       commande1Edit.text := 'Set';
       edit1.text := 'Zro';
       pointRB.isChecked := true;
   end;
   if sender=ExTempsBtn then begin
       chemin := chemin+'simpleTemps/simpleTemps.ino';
       tempsRB.isChecked := true;
       TempsCB.ItemIndex := 2;
       startEdit.text := '';
   end;
   if sender=ExTempsArduinoBtn then begin
       chemin := chemin+'tempsArduino/tempsArduino.ino';
       tempsRB.isChecked := true;
       TempsCB.ItemIndex := 2;
       startEdit.text := 'S';
       tempsArduinoCB.IsChecked := true;
   end;
   if not ShellOpen(chemin) then ShowMessage('impossible de trouver '+#13+chemin);
end;

procedure TArduinoDlg.FormShow(Sender: TObject);
var chemin : string;
begin
   chemin := ExemplesPath+'/Arduino/';
   ExPointBtn.Visible := fileExists(chemin+'simplePoint/simplePoint.ino');
   exTempsBtn.Visible := fileExists(chemin+'simpleTemps/simpleTemps.ino');
   exEtalonBtn.Visible := fileExists(chemin+'etalon/etalon.ino');
   exTempsArduinoBtn.Visible := fileExists(chemin+'tempsArduino/tempsArduino.ino');
   tempsGB.Visible := tempsRB.IsChecked;
   modalResult := mrNone;
end;

procedure TArduinoDlg.PointRBChange(Sender: TObject);
begin
    tempsGB.Visible := tempsRB.IsChecked;
end;

procedure TArduinoDlg.tempsCBChange(Sender: TObject);
begin
    triggerLabel.Visible := tempsCB.ItemIndex=0;
    triggerCB.Visible := tempsCB.ItemIndex=0;
    monocoupCB.Visible := tempsCB.ItemIndex=0;
end;

end.
