unit arduinoOscCfg;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  system.math,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.ListBox,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.TMSBaseControl, FMX.TMSGridCell,
  FMX.TMSGridOptions, FMX.TMSGridData, FMX.TMSCustomGrid, FMX.TMSGrid,
  Winsoft.OSX.ComPort, FMX.Layouts, FMX.Edit, FMX.EditBox, FMX.SpinBox,
  FMX.ScrollBox, FMX.Memo, FMX.Memo.Types;

type
  TArduinoOscilloDlg = class(TForm)
    GroupBox1: TGroupBox;
    BaudCB: TComboBox;
    DeviceNameCB: TComboBox;
    OKbtn: TButton;
    Label1: TLabel;
    UnoBtn: TButton;
    DueBtn: TButton;
    CurieBtn: TButton;
    EscapeBtn: TButton;
    GroupBox2: TGroupBox;
    NbreCB: TComboBox;
    Label2: TLabel;
    LabelSinc: TLabel;
    sincSB: TSpinBox;
    SincCB: TCheckBox;
    Label3: TLabel;
    ResolutionCB: TComboBox;
    Memo1: TMemo;
    procedure UnoBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure NbreCBChange(Sender: TObject);
    procedure SincCBChange(Sender: TObject);
  private
    procedure Maj;
  public
  end;

var
  ArduinoOscilloDlg: TArduinoOscilloDlg;

implementation

{$R *.fmx}

uses regutil, images, arduinoGraphe;

procedure TArduinoOscilloDlg.NbreCBChange(Sender: TObject);
begin
     Maj;
end;

procedure TArduinoOscilloDlg.SincCBChange(Sender: TObject);
begin
     Maj;
end;

procedure TArduinoOscilloDlg.UnoBtnClick(Sender: TObject);
var chemin : string;
begin
   chemin := ExemplesPath+'/Arduino/';
   if sender=DueBtn then begin
       chemin := chemin+'oscilloDue/oscilloDue.ino';
       resolutionCB.itemIndex := 2;
       nbreCB.ItemIndex := 0;
       baudCB.ItemIndex := 4;
   end;
   if sender=CurieBtn then begin
       chemin := chemin+'oscilloCurie101/oscilloCurie101.ino';
       resolutionCB.itemIndex := 1;
       nbreCB.ItemIndex := 1;
       baudCB.ItemIndex := 3;
   end;
   if sender=UnoBtn then begin
       chemin := chemin+'oscillo/oscillo.ino';
       resolutionCB.itemIndex := 1;
       nbreCB.ItemIndex := 2;
       baudCB.ItemIndex := 4;
   end;
   if not ShellOpen(chemin) then ShowMessage('impossible de trouver '+#13+chemin);
end;

procedure TArduinoOscilloDlg.FormShow(Sender: TObject);
var chemin : string;
begin
   chemin := ExemplesPath+'/Arduino/';
   UnoBtn.Visible := fileExists(chemin+'oscilloDue/oscilloDue.ino');
   CurieBtn.Visible := fileExists(chemin+'oscillo/oscillo.ino');
   DueBtn.Visible := fileExists(chemin+'oscilloCurie101/oscilloCurie101.ino');
   modalResult := mrNone;
   Maj;
end;

procedure TArduinoOscilloDlg.MaJ;
begin
    sincSB.Max := floor(maxVecteurArduino/strToInt(NbreCB.Items[NbreCB.itemIndex]));
    if sincSB.Max<2 then begin
       sincCB.IsChecked := false;
       sincCB.visible := false;
    end
    else sincCB.visible := true;
    if sincSB.Max>ordremaxSinc then sincSB.Max := ordremaxSinc;
    sincSB.Visible := sincCB.visible;
    labelsinc.Visible := sincCB.visible;
end;

end.
