unit curmodel;

interface

Uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,
  System.Variants,
  System.IniFiles,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.Menus,
  FMX.Grid,
  FMX.ExtCtrls,
  FMX.ListBox,
  FMX.TreeView,
  FMX.Memo,
  FMX.TabControl,
  FMXTee.RadioGroup,
  FMX.Layouts,
  FMX.Edit,
  FMX.Platform,
  FMX.Bind.Editors,
  FMX.Bind.Navigator,
  FMX.StdCtrls,

  aidekey,
  compile,
  constreg,
  regutil, System.Rtti, FMX.Grid.Style, FMX.ScrollBox, FMX.Controls.Presentation;


type
  TCurseurModeleDlg = class(TForm)
    FermeBtn: TButton;
    HelpBtn: TButton;
    Tableau: TStringGrid;
    GroupBox1: TGroupBox;
    Memo: TMemo;
    RazBtn: TButton;
    PrintBtn: TButton;
    CopyBtn: TButton;
    TriBtn: TButton;
    LigneCombo: TComboBox;
    procedure FermeBtnClick(Sender: TObject);
    procedure TableauKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure LigneComboClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
  private
  public
    equation : boolean;
    ligneXdeY : integer;
  end;

var
  CurseurModeleDlg: TCurseurModeleDlg;

implementation

uses GraphVar, GraphKer, Regdde;

{$R *.FMX}

procedure TCurseurModeleDlg.FermeBtnClick(Sender: TObject);
begin
     Close
end;

procedure TCurseurModeleDlg.TableauKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin with tableau do
     if (LigneRappelCourante=lrXdeY) and (key=vkReturn) and (columnIndex<2) then begin
         equation := columnIndex=1;
         ligneXdeY := selected;
         FgrapheVariab.calculCurseurModele;
         if selected<(rowCount-1) then selected := selected+1;
     end;
end;

procedure TCurseurModeleDlg.FormActivate(Sender: TObject);
begin
     inherited;
     case ligneRappelCourante of
          lrXdeY : if NbreModele>0
               then caption := stValeurModele
               else caption := stValeurReticule;
          lrEquivalence : caption := stEquivalence;
       //   lrTangente : caption := stTangente;
          lrReticule : caption := stValeurReticule;
     end;
     if ligneRappelCourante in [lrEquivalence,lrTangente]
           then begin
            //   LigneCombo.itemIndex := ord(PstyleTangente);
           end
           else begin
               LigneCombo.itemIndex := ord(PstyleReticule);
           end;
end;

procedure TCurseurModeleDlg.RazBtnClick(Sender: TObject);
var p : codePage;
    i : integer;
begin
     for p := 1 to maxPages do begin
         FgrapheVariab.graphe.PaintBox.repaint;
     end;
     with tableau do begin
         rowCount := 3;
         for i := 0 to 2 do cells[i,2] := '';
     end;
     tableau.repaint;
end;

procedure TCurseurModeleDlg.LigneComboClick(Sender: TObject);
begin
     if ligneRappelCourante in [lrEquivalence,lrTangente]
        then //PstyleTangente := TStrokeDash(LigneCombo.itemIndex)
        else PstyleReticule := TStroke.Dash(LigneCombo.itemIndex)
end;

procedure TCurseurModeleDlg.CopyBtnClick(Sender: TObject);
begin
     formDDE.RazRTF;
     formDDE.AjouteMemo(memo);
     formDDE.AjouteGrid(Tableau);
     formDDE.EnvoieRTF;
end;

end.


