unit regdde;

interface

uses
  System.SysUtils,
  System.Types,
  System.UITypes,
  System.Classes,
  System.Variants,
  System.IniFiles,
  System.Math,
  FMX.Types,
  FMX.Controls,
  FMX.Forms,
  FMX.Dialogs,
  FMX.Objects,
  FMX.Menus,
  FMX.Grid,
  FMX.ExtCtrls,
  FMX.ListBox,
  FMX.TreeView,
  FMX.Memo,
  FMX.TabControl,
  FMXTee.RadioGroup,
  FMX.Layouts,
  FMX.Edit,
  FMX.Platform,
  FMX.Bind.Editors,
  FMX.Bind.Navigator,
  FMX.Controls.Presentation,
  FMX.ScrollBox,

  compile,
  constreg,
  graphker,
  maths,
  regutil,
  valeurs;


type
  TformatSepare = (sTab,sBlanc,sCSV);

  TFormDDE = class(TForm)
    Editor: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    avecTab : TformatSepare;
    donnees : TstringList;
    DecodeVariab,DecodeConst : array[codeGrandeur] of integer;
    isPrecVariab,isPrecConst : array[codeGrandeur] of boolean;
    NbrePrecVariab,NbrePrecConst : integer;    
    NbreVariabAlire : integer;
    separateurCSV : char;
    function GetDataReg : boolean;
    function AjouteData : integer;
    Function ExtraitValeur(Agenre : TgenreGrandeur;const s : string;imax : integer) : boolean;
    Function ExtraitIncert(var ligne : integer) : boolean;
    Function ExtraitVariableTexte(var ligne : integer) : boolean;
    Function ExtraitRepere(var ligne : integer) : boolean;
    Procedure extraitNom(const s : string;var ListeN,ListeU : TstringList;creation : boolean);
    procedure ChercheTab;
    procedure MemoAddComm(Astr : string);
  public
     Procedure RazRTF;
     procedure AjouteMemo(Amemo : TMemo);
     procedure AjouteGrid(Agrid : TstringGrid);
     procedure AjouteStringList(AstringList : TstringList);
     procedure EnvoieRTF;
     Function  ImportePressePapier : boolean;
     Function  ImporteFichierTableur(const NomFichier : string) : boolean;
     Function  AjouteFichierTableur(const NomFichier : string) : boolean;
     Procedure AjoutePressePapier;
     Procedure ClipLoad;
     Procedure FocusReg();
  end;

var
  FormDDE: TFormDDE;

implementation

uses RegMain, Graphvar, options;

const NbreTab = 8;

var indexTime,indexDate,indexDateTime,indexTexte : integer;

{$R *.FMX}

Function LigneVide(Astr : string) : boolean;
begin
      trimComplet(Astr);
      result := Astr=''
end;

Procedure TformDDE.extraitNom(const s : string;
                        var ListeN,ListeU : TstringList;creation : boolean);

Procedure extraitNomLoc;
var j,debut,long : integer;
    nomU : string;
    posParentheseO,posParentheseF : integer;
begin
    j := 1;
    Repeat
        while (j<length(s)) and
              not isLettre(s[j]) do inc(j);
        debut := j;
        while (j<=length(s)) and
              isCaracGrandeur(s[j]) do inc(j);
        if j<>debut then begin
            long := j-debut;
            nomU := copy(s,debut+long,length(s));
            if long>16 then long := 16;
            listeN.Add(copy(s,debut,long));
            posParentheseO := pos('(',nomU); // grandeur sous forme : nom (unite)
            posParentheseF := pos(')',nomU);
            if (posParentheseO>0) and (posParentheseF>posParentheseO)
               then begin
                   nomU := copy(nomU,posParentheseO+1,posParentheseF-posParentheseO-1);
                   repeat inc(j) until s[j]=')';
               end
               else nomU := '';
            listeU.Add(nomU);
        end;
     Until (j>=length(s)) or (listeN.count=32);
end;

Procedure extraitNomTab;
var j,debut,posIn : integer;
    nomLoc,nomU : string;
    posParentheseO,posParentheseF : integer;
begin
    j := 1;
    Repeat
        debut := j;
        while (j<=length(s)) and (s[j]<>crTab) do inc(j);
        nomLoc := copy(s,debut,j-debut);
        posIn := pos(' in ',nomLoc);
        if posIn>0 then begin
           nomLoc[posIn] := '(';
           delete(nomLoc,posIn+1,3);
           nomLoc := nomLoc + ')';
        end;
        trimComplet(nomLoc);
        if nomLoc='Magnum' then nomLoc := 'x';
        posParentheseO := pos('(',nomLoc);
        posParentheseF := pos(')',nomLoc);
        if (posParentheseO>0) and (posParentheseF>(posParentheseO+1))
           then begin
              nomU := copy(nomLoc,posParentheseO+1,posParentheseF-posParentheseO-1);
              nomLoc := copy(nomLoc,1,pred(posParentheseO));
           end
           else nomU := '';
        if (nomLoc='') and Creation then nomLoc := 'x'+intToStr(listeN.count);
        listeN.Add(nomLoc);
        listeU.Add(nomU);
        inc(j);
     Until (j>length(s)) or (listeN.count=32);
     if listeN[listeN.count-1]='' then begin
            // cas de dataDirect #9#9 pour trois variables ?
        if creation then listeN.Add('Z') else listeN.Add('');
        listeU.Add('');
     end;
end;

Procedure extraitNomCSV;
var j,debut : integer;
    nomLoc,nomU : string;
    posParentheseO,posParentheseF : integer;
begin
    j := 1;
    Repeat
        debut := j;
        while (j<=length(s)) and (s[j]<>separateurCSV) do inc(j);
        nomLoc := copy(s,debut,j-debut);
        trimComplet(nomLoc);
        posParentheseO := pos('(',nomLoc);
        posParentheseF := pos(')',nomLoc);
        if (posParentheseO>0) and (posParentheseF>(posParentheseO+1))
           then begin
              nomU := copy(nomLoc,posParentheseO+1,posParentheseF-posParentheseO-1);
              nomLoc := copy(nomLoc,1,pred(posParentheseO));
           end
           else nomU := '';
        if (nomLoc='') and Creation then nomLoc := 'x'+intToStr(listeN.count);   
        listeN.Add(nomLoc);
        listeU.Add(nomU);
        inc(j);
     Until (j>length(s)) or (listeN.count=32);
end;

begin
   listeN.clear;
   listeU.clear;
   case avecTab of
        sTab :  extraitNomTab;
        sBlanc : extraitNomLoc;
        sCSV : extraitNomCSV;
   end;
end;

Function LigneDeChiffres(const s : String) : boolean;
var j : integer;
    AvecChiffres : boolean;
begin
    Result := false;
    AvecChiffres := false;
    for j := 1 to length(s) do
        if charinset(s[j],caracNombre) or
           (charinset(s[j],caracPrefixe) and (j>1) and
           charinset(s[j-1],chiffre))
           then avecChiffres := true
           else if not charinset(s[j],separateur) then exit;
    result := avecChiffres;
end;

Function TFormDDE.ExtraitValeur(Agenre : TgenreGrandeur;
                             const s : string;imax : integer) : boolean;

Function ExtraitValeurLoc : boolean;
var jfin,jdebut : integer;
    i : integer;
    index : integer;
    valeur : array[codeGrandeur] of reel;
    strValeur,texte : string;
    posDate,posTime : integer;
begin with pages[pageCourante] do begin
    result := (length(s)>0) and (s[1]<>symbReg2);
    if not result then exit;
    i := 0;jfin := 1;
    try
    Repeat
        jdebut := jfin;
        while (jdebut<length(s)) and
              not charinset(s[jdebut],chiffreWin) do inc(jdebut);
        jfin := jdebut;
        while (jfin<=length(s)) and
              charinset(s[jfin],caracNombre) do inc(jfin);
        strValeur := copy(s,jdebut,jfin-jdebut);
        posTime := pos(':',strValeur);
        posDate := pos('/',strValeur);
        if (posTime>0) or (posDate>0)
            then begin
                try
                if Agenre=variable
                    then index := decodeVariab[i]
                    else index := decodeConst[i];
                if posTime>0
                   then if posDate>0
                        then begin
                            valeur[i] := StrToDateTime(strValeur);
                            Grandeurs[index].formatU := fDateTime;
                            indexDateTime := index;
                        end
                        else begin
                           valeur[i] := StrToTime(strValeur);
                           indexTime := index;
                           Grandeurs[index].formatU := fTime;
                        end
                   else begin
                        valeur[i] := StrToDate(strValeur);
                        indexDate := index;
                        Grandeurs[index].formatU := fDate;                        
                   end;
                 except
                   valeur[i] := Nan;
                 end;
             end
             else if i=indexTexte
               then texte := strValeur
               else valeur[i] := strToFloatWin(strValeur);
        inc(i);
    Until (jfin>=length(s)) or (i>=imax);
    imax := pred(i);
    if Agenre=variable
       then begin
           nmes := nmes+1;
           for i := 0 to imax do begin
               index := decodeVariab[i];
               if i=indexTexte
                  then texteVar[index,pred(Nmes)] := texte //??
                     else if isPrecVariab[i]
                          then incertVar[index,pred(Nmes)] := valeur[i]
                          else valeurVar[index,pred(Nmes)] := valeur[i];
           end;
       end
       else for i := 0 to imax do begin
            index := decodeConst[i];
            if isPrecConst[i]
               then incertConst[index] := valeur[i]
               else valeurConst[index] := valeur[i];
       end
     except
       result := false
     end;
end end; // extraitValeurLoc

Function ExtraitValeurTab : boolean;
var j,jDebut : integer;
    i : integer;
    k,kk : integer;
    index : integer;
    valeur : array[codeGrandeur] of reel;
    strValeur : string;
    posDate,posTime : integer;
    valeurNonDef : boolean;

Procedure TrimStrValeur;
var longueur,posCourant : integer;
begin
     longueur := Length(strValeur);
     posCourant := 1;
     while (posCourant<=longueur) do
         if charinset(strValeur[posCourant],chiffreWin+[':','/'])
            then inc(posCourant)
            else if (posCourant=longueur) and
                    charinset(strValeur[posCourant],caracPrefixe)
                 then convertitPrefixe(strValeur)
                 else begin
                      Delete(strValeur,posCourant,1);
                      dec(longueur);
                 end;
end;

begin with pages[pageCourante] do begin
    result := (length(s)>0) and (s[1]<>symbReg2);
    if not result then exit;
    i := 0;j := 1;
    valeurNonDef := false;
    result := false;
    Repeat
        jDebut := j;
        while (j<=length(s)) and (s[j]<>crTab) do inc(j);
   // s[j]=crTab
        strValeur := copy(s,jdebut,j-jdebut);
        trimStrValeur;
        posTime := pos(':',strValeur);
        posDate := pos('/',strValeur);
        try
        if (posTime>0) or (posDate>0)
            then begin
                if Agenre=variable
                    then index := decodeVariab[i]
                    else index := decodeConst[i];
                if posTime>0
                   then if posDate>0
                        then begin
                            valeur[i] := StrToDateTime(strValeur);
                            Grandeurs[index].formatU := fDateTime;
                        end
                        else begin
                           valeur[i] := StrToTime(strValeur);
                           indexTime := index;
                           Grandeurs[index].formatU := fTime;
                        end
                   else begin
                        valeur[i] := StrToDate(strValeur);
                        indexDate := index;
                        Grandeurs[index].formatU := fDate;
                   end
             end
             else valeur[i] := strToFloatWin(strValeur);
        result := true;
        except
              valeur[i] := Nan;
              valeurNonDef := true;
        end;
        inc(i);
        inc(j);
        if (i=imax) and valeurNonDef and (j<length(s)) then begin
            k := -1;
            repeat inc(k)
            until (k=imax) or isNan(valeur[k]);
            if k<imax then begin
               for kk := k to (imax-2) do valeur[kk] := valeur[succ(kk)];
               dec(i);
            end;
        end;
    until (j>length(s)) or (i=imax);
    imax := pred(i);
    if Agenre=variable
       then begin
           nmes := nmes+1;
           for i := 0 to imax do begin
               index := decodeVariab[i];
               if isPrecVariab[i]
                  then incertVar[index,pred(Nmes)] := valeur[i]
                  else valeurVar[index,pred(Nmes)] := valeur[i];
               // texteVar[index,pred(Nmes)] := texte;
           end
       end
       else for i := 0 to imax do begin
               index := decodeConst[i];
               if isPrecConst[i]
                   then incertConst[index] := valeur[i]
                   else valeurConst[index] := valeur[i];
       end;
end end; // extraitValeurTab

Function ExtraitValeurCSV : boolean;
var j,jDebut : integer;
    i : integer;
    k,kk : integer;
    index : integer;
    valeur : array[codeGrandeur] of reel;
    strValeur : string;
    posDate,posTime : integer;
    valeurNonDef : boolean;

Procedure TrimStrValeur;
var longueur,posCourant : integer;
begin
     longueur := Length(strValeur);
     posCourant := 1;
     while (posCourant<=longueur) do
         if charinset(strValeur[posCourant],chiffreWin+[':','/'])
            then inc(posCourant)
            else begin
                 Delete(strValeur,posCourant,1);
                 dec(longueur);
            end;
end;

begin with pages[pageCourante] do begin
    result := length(s)>0;
    if not result then exit;
    i := 0;j := 1;
    valeurNonDef := false;
    result := false;
    Repeat
        jDebut := j;
        while (j<=length(s)) and (s[j]<>separateurCSV) do inc(j);
// s[j]=separateur 
        strValeur := copy(s,jdebut,j-jdebut);
        trimStrValeur;
        posTime := pos(':',strValeur);
        posDate := pos('/',strValeur);
        try
        if (posTime>0) or (posDate>0)
            then begin
                if Agenre=variable
                    then index := decodeVariab[i]
                    else index := decodeConst[i];
                if posTime>0
                   then if posDate>0
                        then begin
                            valeur[i] := StrToDateTime(strValeur);
                            Grandeurs[index].formatU := fDateTime;
                        end
                        else begin
                           valeur[i] := StrToTime(strValeur);
                           indexTime := index;
                           Grandeurs[index].formatU := fTime;
                        end
                   else begin
                        valeur[i] := StrToDate(strValeur);
                        indexDate := index;
                        Grandeurs[index].formatU := fDate;
                   end
             end
             else valeur[i] := strToFloatWin(strValeur);
        result := true;
        except
              valeur[i] := Nan;
              valeurNonDef := true;
        end;
        inc(i);
        inc(j);
        if (i=imax) and valeurNonDef and (j<length(s)) then begin
            k := -1;
            repeat inc(k)
            until (k=imax) or isNan(valeur[k]);
            if k<imax then begin
               for kk := k to (imax-2) do valeur[kk] := valeur[succ(kk)];
               dec(i);
            end;
        end;
    until (j>length(s)) or (i=imax);
    imax := pred(i);
    if Agenre=variable
       then begin
           nmes := nmes+1;
           for i := 0 to imax do begin
               index := decodeVariab[i];
               valeurVar[index,pred(Nmes)] := valeur[i];
           end
       end
       else for i := 0 to imax do
            valeurConst[decodeConst[i]] := valeur[i];
end end; // extraitValeurCSV

begin
   case avecTab of
      sTab : result := extraitValeurTab;
      sBlanc :  result := extraitValeurLoc;
      sCSV :  result := extraitValeurCSV;
      else result := false;
   end;
end;

Function TFormDDE.ExtraitIncert(var ligne : integer) : boolean;

Function ExtraitValeurIncert(const s : string;N : integer) : boolean;
var jfin,jdebut : integer;
    i : integer;
    valeur : reel;
begin with pages[pageCourante] do begin
    result := true;
    i := 0;jfin := 1;
    try
    Repeat
        jdebut := jfin;
        while (jdebut<length(s)) and
              not charinset(s[jdebut],chiffreWin) do inc(jdebut);
        jfin := jdebut;
        while (jfin<=length(s)) and
              charinset(s[jfin],chiffreWin) do inc(jfin);
        valeur := strToFloatWin(copy(s,jdebut,jfin-jdebut));
        incertVar[decodeVariab[i],N] := valeur;
        inc(i);
    Until (jfin>=length(s)) or (i>=NbreVariab);
    except
          result := false;
    end;
end end; // extraitValeurIncert

var NbreLigne,j : integer;
    s : string;
begin with pages[pageCourante] do begin
    if ligne>=Donnees.count then begin
       result := false;
       exit;
    end;
    s := Donnees[ligne];
    result := (pos('INCERT',s)>0) and (s[1]=symbReg2);
    if not result then exit;
    inc(ligne);
    NbreLigne := NbreLigneWin(s);
    for j := 0 to pred(NbreLigne) do begin
         extraitValeurIncert(Donnees[ligne],j);
         inc(ligne);
    end;
    result := true;
end end; // extraitIncert

Function TFormDDE.ExtraitVariableTexte(var ligne : integer) : boolean;
var NbreLigne,j,index : integer;
    s : string;
begin with pages[pageCourante] do begin
    if ligne>=Donnees.count then begin
       result := false;
       exit;
    end;
    s := Donnees[ligne];
    result := (pos('VARIAB_TEXTE',s)>0) and (s[1]=symbReg2);
    if not result then exit;
    NbreLigne := NbreLigneWin(s);
    result := NbreLigne=(nmes+1);
    if not result then exit;
    inc(ligne); // nom de la variable texte
    index := indexNom(Donnees[ligne]);
    result := index>0;
    if not result then begin
       inc(ligne,NbreLigne);
       exit;
    end;
    inc(ligne); // les valeurs
    grandeurs[index].fonct.genreC := g_texte;
    for j := 0 to pred(nmes) do begin
         s := Donnees[ligne];
         texteVar[index,j] := s;
         inc(ligne);
    end;
    result := true;
end end; // extraitVariableTexte

Function TFormDDE.ImportePressePapier : boolean;
begin
     result := false;
          Donnees.clear;
   //       Donnees.text := ClipBoard.asText;
// tout de suite avant que le presse papiers change             
          if not FregressiMain.VerifSauve then exit;
          if GetDataReg then begin
                result := true;
                NomFichierData := '';
                ModeAcquisition := AcqClipBoard;
                FregressiMain.FinOuvertureFichier(true);
                FregressiMain.sauveEtatCourant;
                ModifFichier := true;
          end;
          donnees.clear;
end;

procedure TFormDDE.FocusReg;
begin
    lectureFichier := false;
    lecturePage := false;
    FregressiMain.PanelStatut.Visible := NbrePages>0;
    if (FgrapheVariab<>nil)
       then FgrapheVariab.show
       else FregressiMain.show;
end;

Procedure TFormDDE.ClipLoad;
begin
     FregressiMain.grandeursOpen;
     FregressiMain.grapheOpen;
     if ImportePressePapier then begin
     end;
end;

Procedure TFormDDE.AjoutePressePapier;
var sauveModeAcq : TmodeAcquisition;
begin
     if pageCourante=0 then begin
        ImportePressePapier;
        exit;
     end;
     Donnees.clear;
//     Donnees.text := ClipBoard.asText;
     LecturePage := true;
     case AjouteData of
        idOK : ;
        idYes : begin
           sauveModeAcq := modeAcquisition;
           importePressePapier;
           modeAcquisition := sauveModeAcq;
           FgrapheVariab.show;
        end;
        idCancel : ;
     end;
     donnees.Clear;
     LecturePage := false;     
end; // AjoutePressePapier

Function TFormDDE.AjouteData : integer;
var i : integer;
    listeNom,listeUnite : TstringList;
    NbreVariabLu : integer;

Function ChercheVariab : boolean;
var i,j,k,kc : integer;
    libre : boolean;
 { TODO : Vrifier les doublons de nom }
begin
  NbreVariabAlire := NbreVariabExp+NbreVariabTexte;
  NbreVariabLu := 0;
  for i := 0 to MaxGrandeurs do DecodeVariab[i] := grandeurInconnue;
  for i := 0 to pred(listeNom.count) do begin
        k := indexNom(listeNom[i]);
        if k<>grandeurInconnue
          then begin
             inc(NbreVariabLu);
             DecodeVariab[i] := k;
          end
          else if (pos('sigma_',listeNom[i])<>1)
               then inc(NbreVariabLu);
  end;
  for i := 0 to pred(listeNom.count) do begin
        k := indexNom(listeNom[i]);
        if k=grandeurInconnue then begin  // else decodeVariab dj affect
             if pos('sigma_',listeNom[i])=1
                then begin
                    k := indexNom(copy(listeNom[i],7,length(listeNom[i])-6));
                    isPrecVariab[i] := k<>grandeurInconnue;
                    if isPrecVariab[i]
                       then begin
                           decodeVariab[i] := k;
                           inc(NbrePrecVariab); // decodeVariab non ncessaire
                       end;
                       // else  faire
                end
                else begin
                     kc := 0;
                     repeat
                        libre := true;
                        for j := 0 to pred(NbreVariabLu) do
                            if decodeVariab[j]=kc then begin // dj pris
                               repeat
                                  inc(kc)
                               until ((grandeurs[kc].fonct.genreC=g_experimentale) and
                                      (grandeurs[kc].genreG=variable)) or
                                     (kc=pred(NbreGrandeurs));
                               libre := false;
                               break;
                            end;
                      until libre or (kc=pred(NbreGrandeurs));
                      if libre and
                        (grandeurs[kc].fonct.genreC=g_experimentale) and
                        (grandeurs[kc].genreG=variable) then DecodeVariab[i] := kc;
               end;
        end;
  end;
  if (NbreVariabAlire<NbreVariabLu) then begin
     for i := pred(NbreVariabAlire) downto NbreVariabLu do
         decodeVariab[i] := indexVariabExp[i]; //  amliorer
  end;
  result := true;
end; // ChercheVariab

procedure AjouteConstante;
var NbreConstCB : integer;

Procedure extraitUniteConst(const contenu : string);
var j,debut,long : integer;
    k,c : integer;
begin
    j := 1;
    c := 0;
    Repeat
        debut := j;
        k := decodeConst[c];
        while (j<=length(contenu)) and
              (contenu[j]<>crTab) do inc(j);
        long := j-debut;
        if long>0 then begin
           Grandeurs[k].NomUnite := copy(contenu,debut,long);
           if pos('',Grandeurs[k].nomUnite)>0 then AngleEnDegre := true;
           if pos('rad',Grandeurs[k].nomUnite)>0 then AngleEnDegre := false;
        end;
        inc(c);
        inc(j); { saute Tab }
     Until (j>length(contenu)) or (k>=NbreConstCB);
end;

Procedure affecteNomConst;
var j,jmax : integer;
begin
    extraitNom(Donnees[i],listeNom,listeUnite,true);
    if NbreConstExp>listeNom.count
       then jmax := listeNom.count
       else jmax := NbreConstExp;
    for j := 0 to pred(jmax) do
        decodeConst[j] := IndexNom(listeNom[j]);
    for j := jmax to pred(listeNom.count) do begin
        decodeConst[j] := AjouteExperimentale(listeNom[j],constante);
        grandeurs[decodeConst[j]].nomUnite := listeUnite[j];
    end;
    NbreConstCB := listeNom.count;
end;

Procedure extraitCommConst(const contenu : string);
var j,debut,long : integer;
    k,c : integer;
begin
    j := 1;
    c := 0;
    Repeat
        k := decodeConst[c];
        debut := j;
        while (j<=length(contenu)) and
              (contenu[j]<>crTab) do inc(j);
        long := j-debut;
        if long>0 then begin
           Fvaleurs.Memo.Lines.Add(''''+grandeurs[k].nom+'='+
                        copy(contenu,debut,long));
           grandeurs[k].fonct.expression := copy(contenu,debut,long);
        end;
        inc(c);
        inc(j);
     Until (j>=length(contenu)) or (k>=NbreConstCB);
end;

begin // AjouteConstante
     while (i<Donnees.count) and
           LigneVide(Donnees[i]) do inc(i);
     if (i>=Donnees.count) or
         (Donnees[i][1]=symbReg2) then exit;
     affecteNomConst;
     inc(i);
     if (i>=Donnees.count) or
        (Donnees[i][1]=symbReg2) then exit;
     extraitUniteConst(Donnees[i]);
     inc(i);
     if (i>=Donnees.count) or
         (Donnees[i][1]=symbReg2) then exit;
     if not LigneDeChiffres(Donnees[i]) then begin
        extraitCommConst(Donnees[i]);
        inc(i);
     end;
     if (i>=Donnees.count) or
        (Donnees[i][1]=symbReg2) then exit;
     ExtraitValeur(constante,Donnees[i],NbreConstExp);
     inc(i);
end; // AjouteConstante

Procedure AjouteValeur;
var s : string;
begin
     while (i<Donnees.count) and
           ExtraitValeur(variable,Donnees[i],NbreVariabAlire)
        do inc(i);
     AjouteConstante;
     while i<Donnees.count do begin
         s := Donnees[i];
         if (length(s)>1) and (s[1]=symbReg2)
               then if not ExtraitIncert(i) and
                       not ExtraitVariableTexte(i) and
                       not ExtraitRepere(i)
                            then inc(i)
                            else
               else inc(i);
     end;
     Pages[pageCourante].modifiedP := true;
end; // AjouteValeur

var Contenu,Comm : string;
    LigneNom,Fini : boolean;
    j,k : integer;
    FinContenu : string;
    DataSuppl,dataOK : boolean;
label fin;
begin // AjouteData
     for i := 0 to MaxGrandeurs do begin
         DecodeVariab[i] := indexVariabExp[i];
         isPrecVariab[i] := false;
         NbrePrecVariab := 0;
         DecodeConst[i] := indexConstExp[i];
         isPrecConst[i] := false;
         NbrePrecConst := 0;
     end;
     i := 0;
     result := idCancel;
     chercheTab;
     listeNom := TstringList.Create;
     listeUnite := TstringList.Create;
     LigneNom := true;
     Fini := false;
     Comm := '';
     if avecTab=sTab then while (i<Donnees.count) and not fini do begin
        Contenu := Donnees[i];
        if Length(contenu)>4
           then FinContenu := AnsiUppercase(copy(contenu,length(contenu)-3,4))
           else FinContenu := '';
        fini := pos(crTab,Contenu)<>0;
        if not fini then begin
              if FinContenu='.EXE'
                 then
                 else comm := comm+Contenu;
              inc(i);
        end;
     end; // Tabulation trouve
     fini := false;
     NbreVariabAlire := NbreVariabExp+NbreVariabTexte;
     while (i<Donnees.count) and not fini do begin
        Contenu := Donnees[i];
        Fini := LigneDeChiffres(Contenu);
        if not Fini and LigneNom and (length(Contenu)>2) then begin
               extraitNom(Contenu,listeNom,listeUnite,false);
            { TODO : vrifier listeNom.count<=nbrevariab }
               dataOK := true;
               for j := 0 to pred(listeNom.count) do begin
                   k := indexVariabExp[j];
                   if k<NbreGrandeurs then dataOK := dataOK and (listeNom[j]=grandeurs[k].nom);
                               { TODO : sigma_ }
               end;
               if dataOK then begin
                  result := idOK;
                  NbreVariabLu := listeNom.count;
               end;
               if result<>idOK then if chercheVariab
                   then result := idOK
                   else begin
                      result := idYes;
                      goto fin;
                   end;
               DataSuppl := NbreVariabLu>NbreVariabAlire;
               if NbreVariabLu<>NbreVariabAlire then begin
               end;
               if result<>idOK then goto fin;
               if DataSuppl then begin
                  for i := 0 to pred(listeNom.count) do
                      if DecodeVariab[i]=grandeurInconnue then begin
                         isPrecVariab[i] := pos('sigma_',listeNom[i])=1;
                         if isPrecVariab[i] then begin
                            k := indexNom(copy(listeNom[i],7,length(listeNom[i])-6));
                            isPrecVariab[i] := k<>grandeurInconnue;
                            DecodeVariab[i] := k;
                            inc(NbrePrecVariab);
                         end;
                         if not isPrecVariab[i]
                            then DecodeVariab[i] := AjouteExperimentale(listeNom[i],variable);
                      end;
                  NbreVariabAlire := NbreVariabExp+NbreVariabTexte;
               end;
               for k := 0 to pred(NbreVariabExp) do
                   if DecodeVariab[k]=grandeurInconnue then DecodeVariab[k] := indexVariabExp[k];
               LigneNom := false;
        end;
        if Fini
           then begin
                NbreVariabLu := 0;
                repeat inc(NbreVariabLu)
                until DecodeVariab[NbreVariabLu]=grandeurInconnue;
                dec(NbreVariabLu);
           end
           else inc(i);
     end;
     if i=Donnees.count then begin // pas d'en tte ?
        i := 0;
        while (i<Donnees.count) and
              not ligneDeChiffres(donnees[i]) do inc(i);
        if i=Donnees.count then goto fin;
     end;
     if not ajoutePage then goto fin;
     Pages[pageCourante].commentaireP := Comm;
     ajouteValeur;
     if Pages[PageCourante].nmes=0
        then supprimePage(pageCourante,false)
        else begin
             pages[pageCourante].recalculP;
             lecturePage := false;
             FRegressiMain.WMRegMaj(MajAjoutPage,0);
             ModifFichier := true;
             result := idOK;
        end;
     fin :
     listeNom.free;
     listeUnite.free;
end; // AjouteData

Function TFormDDE.AjouteFichierTableur(const NomFichier : string) : boolean;
var sauveModeAcq : TmodeAcquisition;
    NomFichierCourt : string;
begin
     Donnees.clear;
     try
     Donnees.LoadFromFile(NomFichier);
     lecturePage := true;
     case AjouteData of
         idYes : begin
            sauveModeAcq := modeAcquisition;
            nomFichierCourt := extractFileName(NomFichier)+' : ';
            result := importeFichierTableur(NomFichier);
            if result then pages[pageCourante].commentaireP :=
               nomFichierCourt+' : '+pages[pageCourante].commentaireP;
            modeAcquisition := sauveModeAcq;
         end;
         idOK : result := true;
         idCancel : result := false;
         else result := false;
     end;
     except
         result := false;
     end;
     lecturePage := false;
     donnees.clear;
end; // AjouteFichierTableur

Function TFormDDE.GetDataReg : boolean;
var ligneCourante : integer;
    Comm : string;
    contenu : String;
    listeNom,listeU : TstringList;

Procedure affecteNom(Agenre : TgenreGrandeur);
var i,z : integer;
    isIncert : boolean;
begin
    extraitNom(Contenu,listeNom,listeU,true);
    for i := 0 to pred(listeNom.count) do begin
        isIncert := pos('sigma_',listeNom[i])=1;
        z := grandeurInconnue; // pour le compilateur
        if isIncert then begin // incertitude de qui ?
           z := indexNom(copy(listeNom[i],7,length(listeNom[i])-6));
           isIncert := (z<>grandeurInconnue) and
                       (grandeurs[z].genreG=Agenre);
        end;
        if not isIncert then
           z := AjouteExperimentale(listeNom[i],Agenre);
        if agenre=variable
           then begin
              decodeVariab[i] := z;
              isPrecVariab[i] := isIncert;
              if isIncert then inc(NbrePrecVariab);
           end
           else begin
              decodeConst[i] := z;
              isPrecConst[i] := isIncert;
              if isIncert then inc(NbrePrecConst);
           end;
        grandeurs[z].nomUnite := listeU[i];
    end;
end;

Procedure completeNomVar;

Procedure TrimNomVar(var s : String);
var longueur,posCourant : integer;
    sMaj : String;
begin
     longueur := Length(s);
     posCourant := 1;
     while (posCourant<=longueur) do
         if isCaracGrandeur(s[posCourant])
            then inc(posCourant)
            else begin
                 Delete(s,posCourant,1);
                 dec(longueur);
            end;
     sMaj := AnsiUpperCase(s);
     if sMaj='TEMPERATURE' then s := 'T'
     else if sMaj='HAUT' then s := 'max'
     else if sMaj='BAS' then s := 'min'
     else if sMaj='VITESSE' then s := 'V'
     else if sMaj='BAROMETRE' then s := 'P'
     else if sMaj='HUMIDITE' then s := 'Hum'
     else if sMaj='EXTERIEURE' then s := 'ext'
     else if sMaj='INTERIEURE' then s := 'int'
     else if sMaj='REFROIDISSEMENT' then s := 'Refr'
end;

var liste : TstringList;
    i,imax : integer;
    z1,z2 : string;
begin
    liste := TstringList.Create;
    extraitNom(Contenu,liste,listeU,false);
    imax := pred(liste.count);
    if imax>=NbreVariab then imax := pred(NbreVariab);
    for i := 0 to imax do begin
        Z1 := listeNom[i];
        Z2 := liste[i];
        grandeurs[i].fonct.expression := z1+' '+z2;
        TrimNomVar(Z1);
        TrimNomVar(Z2);
        if ((z1='V') or (z2='V')) and
           (grandeurs[i].nomUnite='') then grandeurs[i].nomUnite := 'm/s';
        if ((z1='T') or (z2='T')) and
           (grandeurs[i].nomUnite='') then grandeurs[i].nomUnite := 'C';
        if ((z1='P') or (z2='P')) and
           (grandeurs[i].nomUnite='') then grandeurs[i].nomUnite := 'hPa';
        if ((z1='Hum') or (z2='Hum')) and
           (grandeurs[i].nomUnite='') then grandeurs[i].nomUnite := '%';
        if (length(Z1)+length(Z2))>16
           then grandeurs[i].nom := copy(Z1,1,16 div 2)+
                                    copy(Z2,1,16 div 2)
           else grandeurs[i].nom := Z1+Z2;
    end;
    liste.free;
end;

Procedure extraitUniteLigne(Agenre : TgenreGrandeur);
var j,debut,long : integer;
    k : integer;
begin
    j := 1;
    if Agenre=variable then k := 0 else k := NbreVariab;
    Repeat
        debut := j;
        while (j<=length(contenu)) and
              (contenu[j]<>crTab) do inc(j);
        long := j-debut;
        if long>0 then begin
           Grandeurs[k].NomUnite := copy(contenu,debut,long);
           if Grandeurs[k].nomUnite='' then AngleEnDegre := true;
           if Grandeurs[k].nomUnite='rad' then AngleEnDegre := false;
        end;
        inc(k);
        inc(j);// saute Tab
     Until (j>length(contenu)) or (k>=NbreGrandeurs);
end;

Procedure extraitCommLigne(Agenre : TgenreGrandeur);
var j,debut,long : integer;
    k : integer;
begin
    j := 1;
    if Agenre=variable then k := 0 else k := NbreVariab;
    Repeat
        debut := j;
        while (j<=length(contenu)) and
              (contenu[j]<>crTab) do inc(j);
        long := j-debut;
        if long>0 then begin
           Fvaleurs.Memo.Lines.Add(''''+grandeurs[k].nom+'='+
                        copy(contenu,debut,long));
           grandeurs[k].fonct.expression := copy(contenu,debut,long);
        end;
        inc(k);
        inc(j);
     Until (j>=length(contenu)) or (k>=NbreGrandeurs);
end;

function ChercheEnTeteVariabFichier : boolean;
var FinEnTete : boolean;
    Code : integer;
    FinContenu : string;


var k : integer;
begin // ChercheEnTeteVariabFichier
     FinEnTete := false;
     Code := 0;
     Comm := '';
     while (ligneCourante<Donnees.count) and not FinEnTete do begin
        Contenu := Donnees[LigneCourante];
        FinEnTete := LigneDeChiffres(Contenu);
        if FinEnTete then break;
        if Length(contenu)>4
           then FinContenu := AnsiUppercase(copy(contenu,length(contenu)-3,4))
           else FinContenu := '';
        if (pos(crTab,Contenu)=0) and (avecTab=sTab)
           then if FinContenu='.EXE'
                then
                else begin
                   MemoAddComm(Contenu);
                   Comm := Contenu;
                 end
           else if (pos(crTab,Contenu)<>0) or
                    (contenu<>'') then if FinContenu='.EXE'
                then
                else begin
                  inc(code);
                  case code of
                      1 : if NbreVariab=0
                         then begin
                            affecteNom(variable);
                            for k := 0 to pred(NbreVariab) do
                                if grandeurs[k].nom='' then begin
                                   code := 0;
                                   break
                                end;
                          end
                          else completeNomVar;
                      2 : extraitUniteLigne(variable);
                      3 : extraitCommLigne(variable);
                  end; {case}
            end; {else}
            inc(LigneCourante);
     end;
     result := NbreGrandeurs>0;
end; // ChercheEnTeteVariabFichier

function ChercheEnTeteVide : boolean;
var i,j,N : integer;
    NombreEnCours : boolean;
begin
    ligneCourante := 0;
    while (ligneCourante<Donnees.count) and
          (length(Donnees[LigneCourante])=0) do inc(LigneCourante);
    contenu := Donnees[LigneCourante];
    if pos(crTab,Contenu)>0 then avecTab := sTab else avecTab := sBlanc;
    Result := false;
    if length(contenu)=0 then exit;
    if not LigneDeChiffres(Contenu) then exit;
    NombreEnCours := charinset(contenu[1],caracNombre);
    if NombreEnCours then N := 1 else N := 0;
    for j := 2 to length(contenu) do
        if charinset(contenu[j],caracNombre) or
           (charinset(contenu[j],caracPrefixe) and
            charinset(contenu[j-1],chiffre))
           then if NombreEnCours
                then
                else begin
                   NombreEnCours := true;
                   inc(N);
                end
           else if charinset(contenu[j],separateur)
                then NombreEnCours := false
                else exit;
    result := N>=1;
    for i := 1 to N do
        AjouteExperimentale('var'+intToStr(i),variable);
end; // ChercheEnTeteVide

function ChercheEnTeteConst : boolean;
var oldNbre : integer;
begin
     oldNbre := NbreGrandeurs;
     while (ligneCourante<Donnees.count) and
           LigneVide(Donnees[LigneCourante]) do inc(ligneCourante);
     result := ligneCourante<Donnees.count;
     if not result then exit;
     Contenu := Donnees[LigneCourante];
     result := contenu[1]<>symbReg2;
     if not result then exit;
     affecteNom(constante);
     result := NbreGrandeurs>OldNbre;
     if not result then exit;
     inc(ligneCourante);
     Contenu := Donnees[LigneCourante];
     extraitUniteLigne(constante);
     inc(LigneCourante);
     Contenu := Donnees[LigneCourante];
     if LigneDeChiffres(Contenu) then exit;
     extraitCommLigne(constante);
     inc(LigneCourante);
end; // ChercheEnTeteConst

label fin;
var i,j,k : integer;
begin // GetDataReg
     FichierTrie := DataTrieGlb;
     optionsDlg.resetConfig;
     for i := 0 to MaxGrandeurs do begin
         DecodeVariab[i] := i;
         DecodeConst[i] := indexConstExp[i];
         isPrecConst[i] := false;
         isPrecVariab[i] := false;
         NbrePrecConst := 0;
         NbrePrecVariab := 0;
     end;
     listeNom := TstringList.Create;
     listeU := TstringList.Create;
     result := false;
     ChercheTab;
     indexTime := grandeurInconnue;
     indexDate := grandeurInconnue;
     indexDateTime := grandeurInconnue;
     indexTexte := grandeurInconnue;
     LigneCourante := 0;
     if not ChercheEnTeteVariabFichier then begin
        if ChercheEnTeteVide and ajoutePage then begin
           pageCourante := 1;
           while (ligneCourante<Donnees.count) and
               ExtraitValeur(variable,Donnees[LigneCourante],NbreVariab+NbrePrecVariab)
               do inc(LigneCourante);
           result := true;
        end;
        goto fin;
     end;
     if not AjoutePage then goto fin;
     pages[1].CommentaireP := Comm;
     pageCourante := 1;
     if indexTexte<>grandeurInconnue then ;
     while (ligneCourante<Donnees.count) and
            ExtraitValeur(variable,Donnees[LigneCourante],NbreVariab+NbrePrecVariab)
        do inc(LigneCourante);
     if (indexTime<>grandeurInconnue) and
        (indexDate<>grandeurInconnue) and
        (indexDateTime=grandeurInconnue) then begin
           with Fvaleurs do begin
                memo.Lines.Add('t='+grandeurs[indexDate].nom+'+'+grandeurs[indexTime].nom);
                memo.Lines.Add('''t=date et heure');
           end;
           with FgrapheVariab,graphe do begin
               k := 0;
               for j := 1 to MaxOrdonnee do begin
                   Coordonnee[j].nomX := 't';
                   while (k=indexDate) or (k=indexTime) do inc(k);
                   if k<NbreGrandeurs then
                      Coordonnee[j].nomY := grandeurs[k].nom;
                   inc(k)
               end;
               Monde[mondeX].Graduation := gLin;
               Monde[mondeX].zeroInclus := false;
               configCharge := true;
           end;
     end;
     if (ligneCourante<(Donnees.count-2)) and
        ChercheEnTeteConst and
        ligneDeChiffres(Donnees[LigneCourante]) then begin
             ExtraitValeur(constante,Donnees[LigneCourante],NbreConst+NbrePrecConst);
             inc(ligneCourante);
     end;
     while ligneCourante<Donnees.count do
           if not ExtraitIncert(ligneCourante)
              and not ExtraitVariableTexte(ligneCourante)
              and not ExtraitRepere(ligneCourante)
                   then inc(ligneCourante);
     result := true;
     fin :
     ListeNom.free;
     ListeU.free;
end; // GetData

Function TformDDE.ImporteFichierTableur(const NomFichier : string) : boolean;
begin
     Donnees.clear;
     try
     Donnees.LoadFromFile(NomFichier);
     except
        on E:exception do begin
           codeErreurF := E.message;
           ImporteFichierTableur := false;
           exit;
        end;
     end;
     try
     if GetDataReg
        then result := true
        else begin
           codeErreurF := erFormat;
           result := false;
        end;
     ModeAcquisition := AcqFichier;
     except
         codeErreurF := erFormat;
         result := false;
     end;
     donnees.Clear;
end; // ImporteFichierTableur

procedure TFormDDE.AjouteMemo(Amemo : TMemo);
var i : integer;
begin
  Editor.lines.Add('');
  for i := 0 to pred(Amemo.lines.count) do
      Editor.lines.Add(Amemo.lines[i]);
  Editor.lines.Add('');
end;

procedure TFormDDE.AjouteStringList(AstringList : TstringList);
var i : integer;
begin
    Editor.lines.Add('');
    for i := 0 to pred(AstringList.count) do
        Editor.lines.Add(AstringList[i]);
end;

procedure TFormDDE.EnvoieRTF;
begin
    Editor.SelStart := 0;
    Editor.SelLength := length(editor.text);
    Editor.copyToClipBoard;
end;

procedure TFormDDE.RazRTF;
begin
    Editor.lines.Clear;
end;

procedure TFormDDE.AjouteGrid(Agrid : TstringGrid);
var r,c,col1,row1,col2 : integer;
    Texte : String;
begin with aGrid do begin
      Editor.lines.Add('');
      if (cells[0,0]='') or
         ((cells[0,0]='i') and (cells[0,1]=''))
        then col1 := 1
        else col1 := 0;
      if permuteColRow
         then begin
            row1 := col1;
            col1 := 0;
            while col1<rowcount do begin
               col2 := col1+nbreTab; { NbreTab colonnes de 10 = 80 carac }
               if col2>=rowCount then col2 := pred(rowCount);
               for r := row1 to pred(columnCount) do begin
                   Texte := '';
                   for c := col1 to col2 do
                       if c<2
                          then Texte := Texte+Agrid.Cells[r,c]+crTab
                          else Texte := Texte+Agrid.cells[r,c]+crTab;
                   delete(Texte,length(texte),1);
                   Editor.lines.Add(Texte);
               end; {for r}
               col1 := col2+1;
            end;
         end {then}
         else begin
            for r := 0 to 1 do begin // texte
                texte := '';
                for c := col1 to pred(columnCount) do
                    Texte := Texte+Agrid.Cells[c,r]+crTab;
                Editor.lines.Add(Texte);
            end;
            for r := 2 to pred(rowCount) do begin // nombre
                texte := '';
                for c := col1 to pred(columnCount) do
                    Texte := Texte+Agrid.cells[c,r]+crTab;
                Editor.lines.Add(Texte);
            end;
        end;
      Editor.lines.Add('');
end end;

procedure TFormDDE.MemoAddComm(Astr : string);
begin
       if Astr<>'' then Fvaleurs.Memo.Lines.Add(''''+Astr)
end;

procedure TFormDDE.ChercheTab;

Function LigneDeChiffres(const s : String) : boolean;
var j : integer;
    AvecChiffres : boolean;
begin
    Result := false;
    AvecChiffres := false;
    for j := 1 to length(s) do
        if charinset(s[j],caracNombre)
           then avecChiffres := true
           else if not charinset(s[j],separateur) then exit;
    result := avecChiffres;
    if result then begin
       if pos(';',s)>0 then begin
          separateurCSV := ';';
          if pos(',',s)>0 then avecTab := sCSV; // 1,23;1,58
       end;
       if pos('.',s)>0 then begin
          separateurCSV := ',';
          if pos(',',s)>0 then avecTab := sCSV; // 1.23,1.59
       end;
    end;
end;

var i : integer;
begin
     AvecTab := sBlanc;
     if (donnees.count<3) then exit;
     i := 0;
     while (AvecTab=sBlanc) and
           (i<Donnees.count) and
           (i<5) do begin
              if pos(crTab,Donnees[i])<>0 then avecTab := sTab;
              inc(i);
     end;
     if (AvecTab=sBlanc) then begin
          i := 0;
          repeat inc(i)
          until (i=Donnees.count) or
                (i=4) or
                ligneDeChiffres(donnees[i]);
     end;
end;


procedure TFormDDE.FormCreate(Sender: TObject);
begin
     donnees := TstringList.create;
end;

procedure TFormDDE.FormDestroy(Sender: TObject);
begin
     donnees.free;
     inherited
end;


Function TFormDDE.ExtraitRepere(var ligne : integer) : boolean;
var NbreLigne,j,posTab : integer;
    valeur : reel;
    s : string;
begin with pages[pageCourante] do begin
    if ligne>=Donnees.count then begin
       result := false;
       exit;
    end;
    s := Donnees[ligne];
    result := (pos('REPERE',s)>0) and (s[1]=symbReg2);
    if not result then exit;
    inc(ligne);
    NbreLigne := NbreLigneWin(s);
    j := 0;
    repeat
        inc(j);
        s := Donnees[ligne];
        posTab := pos(crTab,s);
        if posTab>2 then begin
           valeur := strToFloatWin(copy(s,1,pred(posTab)));
           s := copy(s,succ(posTab),length(s)-posTab);
           ajouteRepere(valeur,s);
        end;
        inc(ligne);
    until j=NbreLigne;
end end; // extraitRepere

end.



